PROGRAM Vergleich


use netcdf

PARAMETER (NX1=357+1,NY1=384+1,NZ1=66)
PARAMETER (NX2=357+1,NY2=384+1,NZ2=66)


INTEGER:: i,j,k
REAL:: D, W, U_zaehl, W_zaehl, zaehl
REAL:: V_zaehl, DKM_zaehl,x,y,z

DIMENSION       U_a5_1(NX1,NY1,NZ1),V_a5_1(NX1,NY1,NZ1),W_a5_1(NX1,NY1,NZ1),DKM_a5_1(NX1,NY1,NZ1)
DIMENSION       x_a5_1(NX1,NY1,NZ1),y_a5_1(NX1,NY1,NZ1),z_a5_1(NX1,NY1,NZ1)
DIMENSION       xu_a5_1(NX1,NY1,NZ1),yv_a5_1(NX1,NY1,NZ1),zw_a5_1(NX1,NY1,NZ1)
! DIMENSION       upol(0:NX1-1,NY1,NZ1), xpol(NX1,NY1,NZ1), ypol(NX1,NY1,NZ1), zpol(NX1,NY1,NZ1)
! DIMENSION       vpol(NX1,NY1,NZ1), wpol(NX1,NY1,NZ1), DKMpol(NX1,NY1,NZ1)
DIMENSION       U_a5_2(NX2,NY2,NZ2),V_a5_2(NX2,NY2,NZ2),W_a5_2(NX2,NY2,NZ2),DKM_a5_2(NX2,NY2,NZ2)
DIMENSION       x_a5_2(NX2,NY2,NZ2),y_a5_2(NX2,NY2,NZ2),z_a5_2(NX2,NY2,NZ2)
DIMENSION       xu_a5_2(NX2,NY2,NZ2),yv_a5_2(NX2,NY2,NZ2),zw_a5_2(NX2,NY2,NZ2)
! DIMENSION       upol2(NX2,NY2,NZ2), xpol2(NX2,NY2,NZ2), ypol2(NX2,NY2,NZ2), zpol2(NX2,NY2,NZ2)
! DIMENSION       vpol2(NX2,NY2,NZ2), wpol2(NX2,NY2,NZ2), DKMpol2(NX2,NY2,NZ2)
DIMENSION       U_a5_2_t(NX2,NY2,NZ2),V_a5_2_t(NX2,NY2,NZ2), x_a5_2_t(NX2,NY2,NZ2), y_a5_2_t(NX2,NY2,NZ2) 
DIMENSION       U_auf_a5_1(NX2,NY2,NZ2),V_auf_a5_1(NX2,NY2,NZ2),W_auf_a5_1(NX2,NY2,NZ2),DKM_auf_a5_1(NX2,NY2,NZ2)
DIMENSION       upol(0:NX1-1,0:NY1-1,0:NZ1-1), xpol(0:NX1-1,0:NY1-1,0:NZ1-1), ypol(0:NX1-1,0:NY1-1,0:NZ1-1), zpol(0:NX1-1,0:NY1-1,0:NZ1-1)
DIMENSION       vpol(0:NX1-1,0:NY1-1,0:NZ1-1), wpol(0:NX1-1,0:NY1-1,0:NZ1-1), DKMpol(0:NX1-1,0:NY1-1,0:NZ1-1)
DIMENSION       upol2(0:NX2-1,0:NY2-1,0:NZ2-1), xpol2(0:NX2-1,0:NY2-1,0:NZ2-1), ypol2(0:NX2-1,0:NY2-1,0:NZ2-1), zpol2(0:NX2-1,0:NY2-1,0:NZ2-1)
DIMENSION       vpol2(0:NX2-1,0:NY2-1,0:NZ2-1), wpol2(0:NX2-1,0:NY2-1,0:NZ2-1), DKMpol2(0:NX2-1,0:NY2-1,0:NZ2-1)



character(len=99) :: path
real,dimension(:,:,:,:),allocatable :: u1, v1, w1, km1       !!!!!!anpassen
real,dimension(:),allocatable :: time,x1,y1,zu1, zw1, xu1, yv1
real,dimension(:,:,:,:),allocatable :: u2, v2, w2, km2       !!!!!!anpassen
real,dimension(:),allocatable :: x2,y2,zu2, zw2, xu2, yv2
real,dimension(:,:,:,:,:),allocatable :: vars
integer,dimension(:),allocatable :: lens,ndimsvar,varids
character(len=99),dimension(:),allocatable :: name_dim,name_var
integer :: unlimitedDimId
integer,dimension(:,:),allocatable :: dimslength
integer,dimension(4) :: start,count
integer :: nx,ny,nz, varstart


!----------------------Einlesen von a5-----------------------

    path = "../OUTPUT/a5-1_av_3d.nc"         !!!!!!!Pfad anpassen
    mode = 0
    call check(nf90_open(path, nf90_nowrite, ncid))
    call check(nf90_inquire(ncid, nDimensions, nVariables, nAttributes, unlimitedDimId))
    allocate(lens(1:nDimensions))
    allocate(name_dim(1:ndimensions),name_var(1:nvariables))
    allocate(varids(1:nvariables),ndimsvar(1:nvariables))
    do i = 1,nDimensions
        call check( nf90_inquire_dimension(ncid,i,name_dim(i),lens(i)) )
  !      print*, trim(name_dim(i)),lens(i),i
    enddo
    do i=1,nvariables
      call check(nf90_inquire_variable(ncid,i,name_var(i),ixtype,ndimsvar(i)))
!       print*, i,trim(name_var(i)),ndimsvar(i)
    enddo
 
    allocate(dimslength(nvariables,4))
    
    varstart=8   !!!!!!hier anpassen: Schleife ab dem Punkt, wo die berechneten Felder losgehen
    
    do i=varstart,nvariables                    
      call check(nf90_inquire_variable(ncid,i,name_var(i),ixtype,ndimsvar(i),dimslength(i,:)))
!      print*, i,trim(name_var(i)),ndimsvar(i),dimslength(i,:)
    enddo
    
    
!     allocate(vars(varstart:nvariables,lens(dimslength(varstart,1)),&
!                   lens(dimslength(varstart,2)),lens(dimslength(varstart,3)),lens(dimslength(varstart,4))))
       
       
!        print*, 'huhu'
       
nx= lens(dimslength(21,1))
 
 ny= lens(dimslength(21,2))
 
 nz= lens(dimslength(21,3))
!  
!  
 tmax= lens(dimslength(21,4))
 
!        
!        
       !hier Variablen angeben, die man haben möchte, 1. allocieren, 2. aus nc lesen:
       
       !1.
                  
    allocate(u1(lens(dimslength(21,1)),&
                  lens(dimslength(21,2)),lens(dimslength(21,3)),lens(dimslength(21,4))))
                  
               
                  
    allocate(v1(lens(dimslength(22,1)),&
                  lens(dimslength(22,2)),lens(dimslength(22,3)),lens(dimslength(22,4))))
                  
    allocate(w1(lens(dimslength(23,1)),&
                  lens(dimslength(23,2)),lens(dimslength(23,3)),lens(dimslength(23,4))))
                  
                  
                  
    allocate(km1(lens(dimslength(24,1)),&
                 lens(dimslength(24,2)),lens(dimslength(24,3)),lens(dimslength(24,4))))
                  
                  
    allocate(x1(nx), xu1(nx), y1(ny), yv1(ny), zu1(nz), zw1(nz))           
! allocate(ustern(tmax))

      !2.
!   
    call check( nf90_get_var(ncid, 21, u1))
    
    call check( nf90_get_var(ncid, 22, v1))
    
    call check( nf90_get_var(ncid, 23, w1))
 
    call check( nf90_get_var(ncid, 24, km1))
    
    call check ( nf90_get_var(ncid,4, x1))
    
    call check ( nf90_get_var(ncid,5, xu1))
    
    call check ( nf90_get_var(ncid,2, zu1))
     
    call check ( nf90_get_var(ncid,3, zw1))     
    
    call check ( nf90_get_var(ncid,6, y1))
    
    call check ( nf90_get_var(ncid,7, yv1))


    
    
      print*,'nx:', nx,'ny:', ny, 'nz:', nz,'tmax:', tmax 
 !----------------------Einlesen von a5-2-----------------------

    path = "../OUTPUT/a5-2_av_3d.nc"         !!!!!!!Pfad anpassen
   
    mode = 0
    call check(nf90_open(path, nf90_nowrite, ncid))
    call check(nf90_inquire(ncid, nDimensions, nVariables, nAttributes, unlimitedDimId))

    deallocate(lens, name_dim,varids,dimslength,name_var,ndimsvar)
    allocate(lens(1:nDimensions))
    allocate(name_dim(1:ndimensions),name_var(1:nvariables))
    allocate(varids(1:nvariables),ndimsvar(1:nvariables))
    do i = 1,nDimensions
        call check( nf90_inquire_dimension(ncid,i,name_dim(i),lens(i)) )
!        print*, trim(name_dim(i)),lens(i),i
    enddo
    do i=1,nvariables
      call check(nf90_inquire_variable(ncid,i,name_var(i),ixtype,ndimsvar(i)))
!       print*, i,trim(name_var(i)),ndimsvar(i)
    enddo
 
    allocate(dimslength(nvariables,4))
    
    varstart=8   !!!!!!hier anpassen: Schleife ab dem Punkt, wo die berechneten Felder losgehen
    
    do i=varstart,nvariables                    
      call check(nf90_inquire_variable(ncid,i,name_var(i),ixtype,ndimsvar(i),dimslength(i,:)))
!      print*, i,trim(name_var(i)),ndimsvar(i),dimslength(i,:)
    enddo
    
    
nx_2= lens(dimslength(21,1))
 
 ny_2= lens(dimslength(21,2))
 
 nz_2= lens(dimslength(21,3))
!  
 tmax2= lens(dimslength(21,4))
 
 
!      tmax2= lens(1)
       !hier Variablen angeben, die man haben möchte, 1. allocieren, 2. aus nc lesen:
       
       !1.
                  
    allocate(u2(lens(dimslength(21,1)),&
                  lens(dimslength(21,2)),lens(dimslength(21,3)),lens(dimslength(21,4))))
                  
    allocate(v2(lens(dimslength(22,1)),&
                  lens(dimslength(22,2)),lens(dimslength(22,3)),lens(dimslength(22,4))))
                  
    allocate(w2(lens(dimslength(23,1)),&
                  lens(dimslength(23,2)),lens(dimslength(23,3)),lens(dimslength(23,4))))
                  
     allocate(km2(lens(dimslength(24,1)),&
                  lens(dimslength(24,2)),lens(dimslength(24,3)),lens(dimslength(24,4))))
                  
                  
    allocate(x2(nx_2), xu2(nx_2), y2(ny_2), yv2(ny_2), zu2(nz_2), zw2(nz_2))              

      !2.
  
    call check( nf90_get_var(ncid, 21, u2))
    
    call check( nf90_get_var(ncid, 22, v2))
    
    call check( nf90_get_var(ncid, 23, w2))
 
    call check( nf90_get_var(ncid, 24, km2))
    
    call check ( nf90_get_var(ncid,4, x2))
    
    call check ( nf90_get_var(ncid,5, xu2))
    
    call check ( nf90_get_var(ncid,2, zu2))
     
    call check ( nf90_get_var(ncid,3, zw2))     
    
    call check ( nf90_get_var(ncid,6, y2))
    
    call check ( nf90_get_var(ncid,7, yv2))

    
    
    
    
    
    
    
  print*,'nx2:', nx_2,'ny2:', ny_2, 'nz2:', nz_2,'tmax2:', tmax2 
     
     t=tmax
     t=3
 
 !Verschiebung des Gitters in m
sdx=162.5 
sdy=162.5
 
x_a5_1(:,:,:)=0.
xu_a5_1(:,:,:)=0.
y_a5_1(:,:,:)=0.
yv_a5_1(:,:,:)=0.
z_a5_1(:,:,:)=0. 
zw_a5_1(:,:,:)=0.
U_a5_1(:,:,:)=0.
V_a5_1(:,:,:)=0.
W_a5_1(:,:,:)=0.
DKM_a5_1(:,:,:)=0.


do j=1,ny
do k=2,nz
do i=1,nx
x_a5_1(i,j,k-1)=x1(i)-sdx
xu_a5_1(i,j,k-1)=xu1(i)-sdx
enddo 
enddo
enddo


do i=1,nx
do k=2,nz
do j=1,ny
y_a5_1(i,j,k-1)=y1(j)-sdy
yv_a5_1(i,j,k-1)=yv1(j)-sdy
enddo
enddo
enddo

! do i=1,nx
! do j=1,ny
do k=2,nz
z_a5_1(1:nx,1:ny,k-1)=zu1(k)
zw_a5_1(1:nx,1:ny,k-1)=zw1(k)
! enddo
! enddo
enddo




do i=1,nx
do k=2,nz
do j=1,ny
U_a5_1(i,j,k-1)=u1(i,j,k,t)
V_a5_1(i,j,k-1)=v1(i,j,k,t)
W_a5_1(i,j,k-1)=w1(i,j,k,t)
DKM_a5_1(i,j,k-1)=km1(i,j,k,t)
enddo
enddo
enddo

  t=tmax2

do j=1,ny
do k=2,nz
do i=1,nx
x_a5_2(i,j,k-1)=x2(i)-sdx
xu_a5_2(i,j,k-1)=xu2(i)-sdx
enddo 
enddo
enddo


do i=1,nx
do k=2,nz
do j=1,ny
y_a5_2(i,j,k-1)=y2(j)-sdy
yv_a5_2(i,j,k-1)=yv2(j)-sdy
enddo
enddo
enddo

do i=1,nx
do j=1,ny
do k=2,nz
z_a5_2(i,j,k-1)=zu2(k)
zw_a5_2(i,j,k-1)=zw2(k)

enddo
enddo
enddo





do i=1,nx
do k=2,nz
do j=1,ny
U_a5_2(i,j,k-1)=u2(i,j,k,t)
V_a5_2(i,j,k-1)=v2(i,j,k,t)
W_a5_2(i,j,k-1)=w2(i,j,k,t)
DKM_a5_2(i,j,k-1)=km2(i,j,k,t)
enddo
enddo
enddo

! OPEN(20,FILE='a5_1.txt')
! OPEN(30,FILE='a5_2.txt')
! 
OPEN(40,FILE='a5_interpol.txt')
! OPEN(50,FILE='a5_ohnei.txt')

U_zaehl=0
V_zaehl=0
W_zaehl=0
DKM_zaehl=0
zaehl=0




dx=2.5
dy=2.5

winkel=2.*3.141592654/360.



!---------------Interpolation der Größen aufs Rechengitter-------------------

!----a5-1--------------------------------------------------
!Anfangs- und Endpunkte von a5-1 fuer den Nahbereich 
ia=48
ie=94
ja=53
je=79



!uwind!!!!!!!!!!!!!!!!!!!!!!!!!!!


do l=1,nx
do m=1,ny-1
do n=1,nz-2

xint=(l-1)*dx-sdx
yint=m*dy-sdy
zint=zw_a5_1(l,m,n)


findin=0.
findjn=0.
findkn=0.

do i=1,nx

if(findin .le.0.) then
if(xu_a5_1(i,m,n) .ge. xint) then
in=i
findin=findin+1.

endif
endif
enddo


do j=1,ny
if(findjn .le. 0.) then
if(y_a5_1(l,j,n) .ge. yint) then
jn=j
findjn=findjn+1.
endif
endif
enddo



do k=1,nz
if(findkn .le. 0.) then
if(z_a5_1(l,m,k) .ge. zint) then

kn=k
findkn=findkn+1.
endif
endif
enddo


IF(U_a5_1(in-1,jn-1,kn-1) .ne. -9999. .and. U_a5_1(in-1,jn-1,kn) .ne. -9999. .and. U_a5_1(in-1,jn,kn-1) .ne. -9999. .and. U_a5_1(in-1,jn,kn) .ne. -9999. .and.  U_a5_1(in,jn-1,kn-1) .ne. -9999. .and. U_a5_1(in,jn-1,kn) .ne. -9999. .and. U_a5_1(in,jn,kn-1) .ne. -9999. .and. U_a5_1(in,jn,kn) .ne. -9999. )THEN




xd=(xint-(xu_a5_1(in-1,jn,kn)))/(xu_a5_1(in,jn,kn)-(xu_a5_1(in-1,jn,kn)))
yd=(yint-(y_a5_1(in,jn-1,kn)))/(y_a5_1(in,jn,kn)-(y_a5_1(in,jn-1,kn)))
zd=(zint-z_a5_1(in,jn,kn-1))/(z_a5_1(in,jn,kn)-z_a5_1(in,jn,kn-1))



 c00=U_a5_1(in-1,jn-1,kn-1)*(1.-xd)+U_a5_1(in,jn-1,kn-1)*xd
 c01=U_a5_1(in-1,jn-1,kn)*(1.-xd)+U_a5_1(in,jn-1,kn)*xd
 c10=U_a5_1(in-1,jn,kn-1)*(1.-xd)+U_a5_1(in,jn,kn-1)*xd
 c11=U_a5_1(in-1,jn,kn)*(1.-xd)+U_a5_1(in,jn,kn)*xd


 c0=c00*(1.-yd)+c10*yd
 c1=c01*(1.-yd)+c11*yd

 c=c0*(1.-zd)+c1*zd
 
 

 upol(in-1,jn-1,kn-1)=c
 ELSE
 upol(in-1,jn-1,kn-1)=-9999.
 
 ENDIF
 
 
 
 xpol(in-1,jn-1,kn-1)=xint
 ypol(in-1,jn-1,kn-1)=yint
 zpol(in-1,jn-1,kn-1)=zint
 

  
enddo
enddo
enddo




!vwind!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

do l=1,nx-1
do m=1,ny
do n=1,nz

xint=l*dx-sdx
yint=(m-1)*dy-sdy
zint=zw_a5_1(l,m,n)

findin=0.
findjn=0.
findkn=0.

do i=1,nx

if(findin .le.0.) then
if(x_a5_1(i,m,n) .ge. xint) then
in=i
findin=findin+1.

endif
endif
enddo


do j=1,ny
if(findjn .le. 0.) then
if(yv_a5_1(l,j,n) .ge. yint) then
jn=j
findjn=findjn+1.
endif
endif
enddo


do k=1,nz
if(findkn .le. 0.) then
if(z_a5_1(l,m,k) .ge. zint) then
kn=k
findkn=findkn+1.
endif
endif
enddo

IF(V_a5_1(in-1,jn-1,kn-1) .ne. -9999. .and. V_a5_1(in-1,jn-1,kn) .ne. -9999. .and. V_a5_1(in-1,jn,kn-1) .ne. -9999. .and. V_a5_1(in-1,jn,kn) .ne. -9999. .and.  V_a5_1(in,jn-1,kn-1) .ne. -9999. .and. V_a5_1(in,jn-1,kn) .ne. -9999. .and. V_a5_1(in,jn,kn-1) .ne. -9999. .and. V_a5_1(in,jn,kn) .ne. -9999. )THEN

xd=(xint-(x_a5_1(in-1,jn,kn)))/(x_a5_1(in,jn,kn)-(x_a5_1(in-1,jn,kn)))
yd=(yint-(yv_a5_1(in,jn-1,kn)))/(yv_a5_1(in,jn,kn)-(yv_a5_1(in,jn-1,kn)))
zd=(zint-z_a5_1(in,jn,kn-1))/(z_a5_1(in,jn,kn)-z_a5_1(in,jn,kn-1))


 c00=V_a5_1(in-1,jn-1,kn-1)*(1.-xd)+V_a5_1(in,jn-1,kn-1)*xd
 c01=V_a5_1(in-1,jn-1,kn)*(1.-xd)+V_a5_1(in,jn-1,kn)*xd
 c10=V_a5_1(in-1,jn,kn-1)*(1.-xd)+V_a5_1(in,jn,kn-1)*xd
 c11=V_a5_1(in-1,jn,kn)*(1.-xd)+V_a5_1(in,jn,kn)*xd


 c0=c00*(1.-yd)+c10*yd
 c1=c01*(1.-yd)+c11*yd

 c=c0*(1.-zd)+c1*zd
 
 vpol(in-1,jn-1,kn-1)=c
 
 ELSE
  vpol(in-1,jn-1,kn-1)=-9999.
 ENDIF

enddo
enddo
enddo



!wwind!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

do l=1,nx-1
do m=1,ny-1
do n=1,nz-1

xint=l*dx-sdx
yint=m*dy-sdy
zint=zw_a5_1(l,m,n)

findin=0.
findjn=0.
findkn=0.

do i=1,nx

if(findin .le.0.) then
if(x_a5_1(i,m,n) .ge. xint) then
in=i
findin=findin+1.

endif
endif
enddo


do j=1,ny
if(findjn .le. 0.) then
if(y_a5_1(l,j,n) .ge. yint) then
jn=j
findjn=findjn+1.
endif
endif
enddo


do k=1,nz
if(findkn .le. 0.) then
if(zw_a5_1(l,m,k) .ge. zint) then
kn=k
findkn=findkn+1.
endif
endif
enddo

IF(W_a5_1(in-1,jn-1,kn-1) .ne. -9999. .and. W_a5_1(in-1,jn-1,kn) .ne. -9999. .and. W_a5_1(in-1,jn,kn-1) .ne. -9999. .and. W_a5_1(in-1,jn,kn) .ne. -9999. .and.  W_a5_1(in,jn-1,kn-1) .ne. -9999. .and. W_a5_1(in,jn-1,kn) .ne. -9999. .and. W_a5_1(in,jn,kn-1) .ne. -9999. .and. W_a5_1(in,jn,kn) .ne. -9999. )THEN

xd=(xint-(x_a5_1(in-1,jn,kn)))/(x_a5_1(in,jn,kn)-(x_a5_1(in-1,jn,kn)))
yd=(yint-(y_a5_1(in,jn-1,kn)))/(y_a5_1(in,jn,kn)-(y_a5_1(in,jn-1,kn)))
zd=(zint-zw_a5_1(in,jn,kn-1))/(zw_a5_1(in,jn,kn)-zw_a5_1(in,jn,kn-1))


 c00=W_a5_1(in-1,jn-1,kn-1)*(1.-xd)+W_a5_1(in,jn-1,kn-1)*xd
 c01=W_a5_1(in-1,jn-1,kn)*(1.-xd)+W_a5_1(in,jn-1,kn)*xd
 c10=W_a5_1(in-1,jn,kn-1)*(1.-xd)+W_a5_1(in,jn,kn-1)*xd
 c11=W_a5_1(in-1,jn,kn)*(1.-xd)+W_a5_1(in,jn,kn)*xd


 c0=c00*(1.-yd)+c10*yd
 c1=c01*(1.-yd)+c11*yd

 c=c0*(1.-zd)+c1*zd
 
 wpol(in-1,jn-1,kn-1)=c
 ELSE
  wpol(in-1,jn-1,kn-1)=-9999.
 ENDIF

enddo
enddo
enddo



!dkm!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

do l=1,nx-1
do m=1,ny-1
do n=1,nz

xint=l*dx-sdx
yint=m*dy-sdy
zint=zw_a5_1(l,m,n)

findin=0.
findjn=0.
findkn=0.

do i=1,nx

if(findin .le.0.) then
if(x_a5_1(i,m,n) .ge. xint) then
in=i
findin=findin+1.

endif
endif
enddo


do j=1,ny
if(findjn .le. 0.) then
if(y_a5_1(l,j,n) .ge. yint) then
jn=j
findjn=findjn+1.
endif
endif
enddo


do k=1,nz
if(findkn .le. 0.) then
if(z_a5_1(l,m,k) .ge. zint) then
kn=k
findkn=findkn+1.
endif
endif
enddo

IF(DKM_a5_1(in-1,jn-1,kn-1) .ne. -9999. .and. DKM_a5_1(in-1,jn-1,kn) .ne. -9999. .and. DKM_a5_1(in-1,jn,kn-1) .ne. -9999. .and. DKM_a5_1(in-1,jn,kn) .ne. -9999. .and.  DKM_a5_1(in,jn-1,kn-1) .ne. -9999. .and. DKM_a5_1(in,jn-1,kn) .ne. -9999. .and. DKM_a5_1(in,jn,kn-1) .ne. -9999. .and. DKM_a5_1(in,jn,kn) .ne. -9999. )THEN

xd=(xint-(x_a5_1(in-1,jn,kn)))/(x_a5_1(in,jn,kn)-(x_a5_1(in-1,jn,kn)))
yd=(yint-(y_a5_1(in,jn-1,kn)))/(y_a5_1(in,jn,kn)-(y_a5_1(in,jn-1,kn)))
zd=(zint-z_a5_1(in,jn,kn-1))/(z_a5_1(in,jn,kn)-z_a5_1(in,jn,kn-1))


 c00=DKM_a5_1(in-1,jn-1,kn-1)*(1.-xd)+DKM_a5_1(in,jn-1,kn-1)*xd
 c01=DKM_a5_1(in-1,jn-1,kn)*(1.-xd)+DKM_a5_1(in,jn-1,kn)*xd
 c10=DKM_a5_1(in-1,jn,kn-1)*(1.-xd)+DKM_a5_1(in,jn,kn-1)*xd
 c11=DKM_a5_1(in-1,jn,kn)*(1.-xd)+DKM_a5_1(in,jn,kn)*xd


 c0=c00*(1.-yd)+c10*yd
 c1=c01*(1.-yd)+c11*yd

 c=c0*(1.-zd)+c1*zd
 
 DKMpol(in-1,jn-1,kn-1)=c
 
 ELSE
  DKMpol(in-1,jn-1,kn-1)=-9999.
 ENDIF

enddo
enddo
enddo



!----a5-2--------------------------------------------------




!uwind!!!!!!!!!!!!!!!!!!!!!!!!!!!


do l=1,nx_2
do m=1,ny_2-1
do n=1,nz_2-1

xint=(l-1)*dx-sdx
yint=m*dy-sdy
zint=zw_a5_2(l,m,n)


findin=0.
findjn=0.
findkn=0.

do i=1,nx_2

if(findin .le.0.) then
if(xu_a5_2(i,m,n) .ge. xint) then
in=i
findin=findin+1.

endif
endif
enddo


do j=1,ny_2
if(findjn .le. 0.) then
if(y_a5_2(l,j,n) .ge. yint) then
jn=j
findjn=findjn+1.
endif
endif
enddo



do k=1,nz_2
if(findkn .le. 0.) then
if(z_a5_2(l,m,k) .ge. zint) then
kn=k
findkn=findkn+1.
endif
endif
enddo

IF(U_a5_2(in-1,jn-1,kn-1) .ne. -9999. .and. U_a5_2(in-1,jn-1,kn) .ne. -9999. .and. U_a5_2(in-1,jn,kn-1) .ne. -9999. .and. U_a5_2(in-1,jn,kn) .ne. -9999. .and.  U_a5_2(in,jn-1,kn-1) .ne. -9999. .and. U_a5_2(in,jn-1,kn) .ne. -9999. .and. U_a5_2(in,jn,kn-1) .ne. -9999. .and. U_a5_2(in,jn,kn) .ne. -9999. )THEN

xd=(xint-(xu_a5_2(in-1,jn,kn)))/(xu_a5_2(in,jn,kn)-(xu_a5_2(in-1,jn,kn)))
yd=(yint-(y_a5_2(in,jn-1,kn)))/(y_a5_2(in,jn,kn)-(y_a5_2(in,jn-1,kn)))
zd=(zint-z_a5_2(in,jn,kn-1))/(z_a5_2(in,jn,kn)-z_a5_2(in,jn,kn-1))



 c00=U_a5_2(in-1,jn-1,kn-1)*(1.-xd)+U_a5_2(in,jn-1,kn-1)*xd
 c01=U_a5_2(in-1,jn-1,kn)*(1.-xd)+U_a5_2(in,jn-1,kn)*xd
 c10=U_a5_2(in-1,jn,kn-1)*(1.-xd)+U_a5_2(in,jn,kn-1)*xd
 c11=U_a5_2(in-1,jn,kn)*(1.-xd)+U_a5_2(in,jn,kn)*xd


 c0=c00*(1.-yd)+c10*yd
 c1=c01*(1.-yd)+c11*yd

 c=c0*(1.-zd)+c1*zd
 

 upol2(in-1,jn-1,kn-1)=c
 ELSE
  upol2(in-1,jn-1,kn-1)=-9999.
 ENDIF
 xpol2(in-1,jn-1,kn-1)=xint
 ypol2(in-1,jn-1,kn-1)=yint
 zpol2(in-1,jn-1,kn-1)=zint
 

enddo
enddo
enddo



!vwind!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

do l=1,nx_2-1
do m=1,ny_2
do n=1,nz_2

xint=l*dx-sdx
yint=(m-1)*dy-sdy
zint=zw_a5_2(l,m,n)

findin=0.
findjn=0.
findkn=0.

do i=1,nx_2

if(findin .le.0.) then
if(x_a5_2(i,m,n) .ge. xint) then
in=i
findin=findin+1.

endif
endif
enddo


do j=1,ny_2
if(findjn .le. 0.) then
if(yv_a5_2(l,j,n) .ge. yint) then
jn=j
findjn=findjn+1.
endif
endif
enddo


do k=1,nz_2
if(findkn .le. 0.) then
if(z_a5_2(l,m,k) .ge. zint) then
kn=k
findkn=findkn+1.
endif
endif
enddo


IF(V_a5_2(in-1,jn-1,kn-1) .ne. -9999. .and. V_a5_2(in-1,jn-1,kn) .ne. -9999. .and. V_a5_2(in-1,jn,kn-1) .ne. -9999. .and. V_a5_2(in-1,jn,kn) .ne. -9999. .and.  V_a5_2(in,jn-1,kn-1) .ne. -9999. .and. V_a5_2(in,jn-1,kn) .ne. -9999. .and. V_a5_2(in,jn,kn-1) .ne. -9999. .and. V_a5_2(in,jn,kn) .ne. -9999. )THEN

xd=(xint-(x_a5_2(in-1,jn,kn)))/(x_a5_2(in,jn,kn)-(x_a5_2(in-1,jn,kn)))
yd=(yint-(yv_a5_2(in,jn-1,kn)))/(yv_a5_2(in,jn,kn)-(yv_a5_2(in,jn-1,kn)))
zd=(zint-z_a5_2(in,jn,kn-1))/(z_a5_2(in,jn,kn)-z_a5_2(in,jn,kn-1))


 c00=V_a5_2(in-1,jn-1,kn-1)*(1.-xd)+V_a5_2(in,jn-1,kn-1)*xd
 c01=V_a5_2(in-1,jn-1,kn)*(1.-xd)+V_a5_2(in,jn-1,kn)*xd
 c10=V_a5_2(in-1,jn,kn-1)*(1.-xd)+V_a5_2(in,jn,kn-1)*xd
 c11=V_a5_2(in-1,jn,kn)*(1.-xd)+V_a5_2(in,jn,kn)*xd


 c0=c00*(1.-yd)+c10*yd
 c1=c01*(1.-yd)+c11*yd

 c=c0*(1.-zd)+c1*zd
 
 vpol2(in-1,jn-1,kn-1)=c
 ELSE
 vpol2(in-1,jn-1,kn-1)=-9999.
 ENDIF

enddo
enddo
enddo



!wwind!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

do l=1,nx_2-1
do m=1,ny_2-1
do n=1,nz_2-1

xint=l*dx-sdx
yint=m*dy-sdy
zint=zw_a5_2(l,m,n)

findin=0.
findjn=0.
findkn=0.

do i=1,nx_2

if(findin .le.0.) then
if(x_a5_2(i,m,n) .ge. xint) then
in=i
findin=findin+1.

endif
endif
enddo


do j=1,ny_2
if(findjn .le. 0.) then
if(y_a5_2(l,j,n) .ge. yint) then
jn=j
findjn=findjn+1.
endif
endif
enddo


do k=1,nz_2
if(findkn .le. 0.) then
if(zw_a5_2(l,m,k) .ge. zint) then
kn=k
findkn=findkn+1.
endif
endif
enddo

IF(W_a5_2(in-1,jn-1,kn-1) .ne. -9999. .and. W_a5_2(in-1,jn-1,kn) .ne. -9999. .and. W_a5_2(in-1,jn,kn-1) .ne. -9999. .and. W_a5_2(in-1,jn,kn) .ne. -9999. .and.  W_a5_2(in,jn-1,kn-1) .ne. -9999. .and. W_a5_2(in,jn-1,kn) .ne. -9999. .and. W_a5_2(in,jn,kn-1) .ne. -9999. .and. W_a5_2(in,jn,kn) .ne. -9999. )THEN

xd=(xint-(x_a5_2(in-1,jn,kn)))/(x_a5_2(in,jn,kn)-(x_a5_2(in-1,jn,kn)))
yd=(yint-(y_a5_2(in,jn-1,kn)))/(y_a5_2(in,jn,kn)-(y_a5_2(in,jn-1,kn)))
zd=(zint-zw_a5_2(in,jn,kn-1))/(zw_a5_2(in,jn,kn)-zw_a5_2(in,jn,kn-1))


 c00=W_a5_2(in-1,jn-1,kn-1)*(1.-xd)+W_a5_2(in,jn-1,kn-1)*xd
 c01=W_a5_2(in-1,jn-1,kn)*(1.-xd)+W_a5_2(in,jn-1,kn)*xd
 c10=W_a5_2(in-1,jn,kn-1)*(1.-xd)+W_a5_2(in,jn,kn-1)*xd
 c11=W_a5_2(in-1,jn,kn)*(1.-xd)+W_a5_2(in,jn,kn)*xd


 c0=c00*(1.-yd)+c10*yd
 c1=c01*(1.-yd)+c11*yd

 c=c0*(1.-zd)+c1*zd
 
 wpol2(in-1,jn-1,kn-1)=c
 ELSE
  wpol2(in-1,jn-1,kn-1)=-9999.
 ENDIF

enddo
enddo
enddo


!dkm!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

do l=1,nx_2-1
do m=1,ny_2-1
do n=1,nz_2

xint=l*dx-sdx
yint=m*dy-sdy
zint=zw_a5_2(l,m,n)

findin=0.
findjn=0.
findkn=0.

do i=1,nx_2

if(findin .le.0.) then
if(x_a5_2(i,m,n) .ge. xint) then
in=i
findin=findin+1.

endif
endif
enddo


do j=1,ny_2
if(findjn .le. 0.) then
if(y_a5_2(l,j,n) .ge. yint) then
jn=j
findjn=findjn+1.
endif
endif
enddo


do k=1,nz_2
if(findkn .le. 0.) then
if(z_a5_2(l,m,k) .ge. zint) then
kn=k
findkn=findkn+1.
endif
endif
enddo

IF(DKM_a5_2(in-1,jn-1,kn-1) .ne. -9999. .and. DKM_a5_2(in-1,jn-1,kn) .ne. -9999. .and. DKM_a5_2(in-1,jn,kn-1) .ne. -9999. .and. DKM_a5_2(in-1,jn,kn) .ne. -9999. .and.  DKM_a5_2(in,jn-1,kn-1) .ne. -9999. .and. DKM_a5_2(in,jn-1,kn) .ne. -9999. .and. DKM_a5_2(in,jn,kn-1) .ne. -9999. .and. DKM_a5_2(in,jn,kn) .ne. -9999. )THEN

xd=(xint-(x_a5_2(in-1,jn,kn)))/(x_a5_2(in,jn,kn)-(x_a5_2(in-1,jn,kn)))
yd=(yint-(y_a5_2(in,jn-1,kn)))/(y_a5_2(in,jn,kn)-(y_a5_2(in,jn-1,kn)))
zd=(zint-z_a5_2(in,jn,kn-1))/(z_a5_2(in,jn,kn)-z_a5_2(in,jn,kn-1))


 c00=DKM_a5_2(in-1,jn-1,kn-1)*(1.-xd)+DKM_a5_2(in,jn-1,kn-1)*xd
 c01=DKM_a5_2(in-1,jn-1,kn)*(1.-xd)+DKM_a5_2(in,jn-1,kn)*xd
 c10=DKM_a5_2(in-1,jn,kn-1)*(1.-xd)+DKM_a5_2(in,jn,kn-1)*xd
 c11=DKM_a5_2(in-1,jn,kn)*(1.-xd)+DKM_a5_2(in,jn,kn)*xd


 c0=c00*(1.-yd)+c10*yd
 c1=c01*(1.-yd)+c11*yd

 c=c0*(1.-zd)+c1*zd
 
 DKMpol2(in-1,jn-1,kn-1)=c
 ELSE
 DKMpol2(in-1,jn-1,kn-1)=-9999.
 ENDIF

enddo
enddo
enddo


!--------------------------------------------------------------------------
!---------------Bestimmung der Normierungsgeschwindigkeit-------------------
!--------------------------------------------------------------------------

!---fuer a5-1------------------------
!Normierungspunkt
xn=-44.19
yn=-44.19
zn=50.


!uwind!!!!!!!!!!!!!!!!!!!!!!!!!!!

findin=0.
findjn=0.
findkn=0.

do i=1,nx

if(findin .le.0.) then
if(xu_a5_1(i,1,1) .ge. xn) then
in=i
findin=findin+1.

endif
endif
enddo


do j=1,ny
if(findjn .le. 0.) then
if(y_a5_1(1,j,1) .ge. yn) then
jn=j
findjn=findjn+1.
endif
endif
enddo


do k=1,nz
if(findkn .le. 0.) then
if(z_a5_1(1,1,k) .ge. zn) then
kn=k
findkn=findkn+1.
endif
endif
enddo




xd=(xn-(xu_a5_1(in-1,jn,kn)))/(xu_a5_1(in,jn,kn)-(xu_a5_1(in-1,jn,kn)))
yd=(yn-(y_a5_1(in,jn-1,kn)))/(y_a5_1(in,jn,kn)-(y_a5_1(in,jn-1,kn)))
zd=(zn-z_a5_1(in,jn,kn-1))/(z_a5_1(in,jn,kn)-z_a5_1(in,jn,kn-1))


 c00=U_a5_1(in-1,jn-1,kn-1)*(1.-xd)+U_a5_1(in,jn-1,kn-1)*xd
 c01=U_a5_1(in-1,jn-1,kn)*(1.-xd)+U_a5_1(in,jn-1,kn)*xd
 c10=U_a5_1(in-1,jn,kn-1)*(1.-xd)+U_a5_1(in,jn,kn-1)*xd
 c11=U_a5_1(in-1,jn,kn)*(1.-xd)+U_a5_1(in,jn,kn)*xd


 c0=c00*(1.-yd)+c10*yd
 c1=c01*(1.-yd)+c11*yd

 c=c0*(1.-zd)+c1*zd
 
 

 unorm=c
!  Print*, 'hh', unorm, in,jn,kn
!vwind!!!!!!!!!!!!!!!!!!!!!!!!!!!

findin=0.
findjn=0.
findkn=0.

do i=1,nx

if(findin .le.0.) then
if(x_a5_1(i,1,1) .ge. xn) then
in=i
findin=findin+1.

endif
endif
enddo


do j=1,ny
if(findjn .le. 0.) then
if(yv_a5_1(1,j,1) .ge. yn) then
jn=j
findjn=findjn+1.
endif
endif
enddo


do k=1,nz
if(findkn .le. 0.) then
if(z_a5_1(1,1,k) .ge. zn) then
kn=k
findkn=findkn+1.
endif
endif
enddo


xd=(xn-(x_a5_1(in-1,jn,kn)))/(x_a5_1(in,jn,kn)-(x_a5_1(in-1,jn,kn)))
yd=(yn-(yv_a5_1(in,jn-1,kn)))/(yv_a5_1(in,jn,kn)-(yv_a5_1(in,jn-1,kn)))
zd=(zn-z_a5_1(in,jn,kn-1))/(z_a5_1(in,jn,kn)-z_a5_1(in,jn,kn-1))


 c00=V_a5_1(in-1,jn-1,kn-1)*(1.-xd)+V_a5_1(in,jn-1,kn-1)*xd
 c01=V_a5_1(in-1,jn-1,kn)*(1.-xd)+V_a5_1(in,jn-1,kn)*xd
 c10=V_a5_1(in-1,jn,kn-1)*(1.-xd)+V_a5_1(in,jn,kn-1)*xd
 c11=V_a5_1(in-1,jn,kn)*(1.-xd)+V_a5_1(in,jn,kn)*xd


 c0=c00*(1.-yd)+c10*yd
 c1=c01*(1.-yd)+c11*yd

 c=c0*(1.-zd)+c1*zd
 
 

 vnorm=c

 !wwind!!!!!!!!!!!!!!!!!!!!!!!!!!!

findin=0.
findjn=0.
findkn=0.

do i=1,nx

if(findin .le.0.) then
if(x_a5_1(i,1,1) .ge. xn) then
in=i
findin=findin+1.

endif
endif
enddo


do j=1,ny
if(findjn .le. 0.) then
if(y_a5_1(1,j,1) .ge. yn) then
jn=j
findjn=findjn+1.
endif
endif
enddo


do k=1,nz
if(findkn .le. 0.) then
if(zw_a5_1(1,1,k) .ge. zn) then
kn=k
findkn=findkn+1.
endif
endif
enddo


xd=(xn-(x_a5_1(in-1,jn,kn)))/(x_a5_1(in,jn,kn)-(x_a5_1(in-1,jn,kn)))
yd=(yn-(y_a5_1(in,jn-1,kn)))/(y_a5_1(in,jn,kn)-(y_a5_1(in,jn-1,kn)))
zd=(zn-zw_a5_1(in,jn,kn-1))/(zw_a5_1(in,jn,kn)-zw_a5_1(in,jn,kn-1))


 c00=W_a5_1(in-1,jn-1,kn-1)*(1.-xd)+W_a5_1(in,jn-1,kn-1)*xd
 c01=W_a5_1(in-1,jn-1,kn)*(1.-xd)+W_a5_1(in,jn-1,kn)*xd
 c10=W_a5_1(in-1,jn,kn-1)*(1.-xd)+W_a5_1(in,jn,kn-1)*xd
 c11=W_a5_1(in-1,jn,kn)*(1.-xd)+W_a5_1(in,jn,kn)*xd


 c0=c00*(1.-yd)+c10*yd
 c1=c01*(1.-yd)+c11*yd

 c=c0*(1.-zd)+c1*zd
 
 

 wnorm=c


 !km!!!!!!!!!!!!!!!!!!!!!!!!!!!

findin=0.
findjn=0.
findkn=0.

do i=1,nx

if(findin .le.0.) then
if(x_a5_1(i,1,1) .ge. xn) then
in=i
findin=findin+1.

endif
endif
enddo


do j=1,ny
if(findjn .le. 0.) then
if(y_a5_1(1,j,1) .ge. yn) then
jn=j
findjn=findjn+1.
endif
endif
enddo


do k=1,nz
if(findkn .le. 0.) then
if(z_a5_1(1,1,k) .ge. zn) then
kn=k
findkn=findkn+1.
endif
endif
enddo


xd=(xn-(x_a5_1(in-1,jn,kn)))/(x_a5_1(in,jn,kn)-(x_a5_1(in-1,jn,kn)))
yd=(yn-(y_a5_1(in,jn-1,kn)))/(y_a5_1(in,jn,kn)-(y_a5_1(in,jn-1,kn)))
zd=(zn-z_a5_1(in,jn,kn-1))/(z_a5_1(in,jn,kn)-z_a5_1(in,jn,kn-1))


 c00=DKM_a5_1(in-1,jn-1,kn-1)*(1.-xd)+DKM_a5_1(in,jn-1,kn-1)*xd
 c01=DKM_a5_1(in-1,jn-1,kn)*(1.-xd)+DKM_a5_1(in,jn-1,kn)*xd
 c10=DKM_a5_1(in-1,jn,kn-1)*(1.-xd)+DKM_a5_1(in,jn,kn-1)*xd
 c11=DKM_a5_1(in-1,jn,kn)*(1.-xd)+DKM_a5_1(in,jn,kn)*xd


 c0=c00*(1.-yd)+c10*yd
 c1=c01*(1.-yd)+c11*yd

 c=c0*(1.-zd)+c1*zd
 
 dkmnorm=c


u_norm=sqrt(unorm**2.+vnorm**2.+wnorm**2.)

print*, 'unorm', unorm, vnorm, wnorm,  u_norm


!---fuer a5-2------------------------
!Normierungspunkt
xn=-62.49
yn=0.
zn=50.


!uwind!!!!!!!!!!!!!!!!!!!!!!!!!!!

findin=0.
findjn=0.
findkn=0.

do i=1,nx

if(findin .le.0.) then
if(xu_a5_2(i,1,1) .ge. xn) then
in=i
findin=findin+1.

endif
endif
enddo


do j=1,ny
if(findjn .le. 0.) then
if(y_a5_2(1,j,1) .ge. yn) then
jn=j
findjn=findjn+1.
endif
endif
enddo


do k=1,nz
if(findkn .le. 0.) then
if(z_a5_2(1,1,k) .ge. zn) then
kn=k
findkn=findkn+1.
endif
endif
enddo


xd=(xn-(xu_a5_2(in-1,jn,kn)))/(xu_a5_2(in,jn,kn)-(xu_a5_2(in-1,jn,kn)))
yd=(yn-(y_a5_2(in,jn-1,kn)))/(y_a5_2(in,jn,kn)-(y_a5_2(in,jn-1,kn)))
zd=(zn-z_a5_2(in,jn,kn-1))/(z_a5_2(in,jn,kn)-z_a5_2(in,jn,kn-1))


 c00=U_a5_2(in-1,jn-1,kn-1)*(1.-xd)+U_a5_2(in,jn-1,kn-1)*xd
 c01=U_a5_2(in-1,jn-1,kn)*(1.-xd)+U_a5_2(in,jn-1,kn)*xd
 c10=U_a5_2(in-1,jn,kn-1)*(1.-xd)+U_a5_2(in,jn,kn-1)*xd
 c11=U_a5_2(in-1,jn,kn)*(1.-xd)+U_a5_2(in,jn,kn)*xd


 c0=c00*(1.-yd)+c10*yd
 c1=c01*(1.-yd)+c11*yd

 c=c0*(1.-zd)+c1*zd
 
 

 unorm2=c

!vwind!!!!!!!!!!!!!!!!!!!!!!!!!!!

findin=0.
findjn=0.
findkn=0.

do i=1,nx

if(findin .le.0.) then
if(x_a5_2(i,1,1) .ge. xn) then
in=i
findin=findin+1.

endif
endif
enddo


do j=1,ny
if(findjn .le. 0.) then
if(yv_a5_2(1,j,1) .ge. yn) then
jn=j
findjn=findjn+1.
endif
endif
enddo


do k=1,nz
if(findkn .le. 0.) then
if(z_a5_2(1,1,k) .ge. zn) then
kn=k
findkn=findkn+1.
endif
endif
enddo


xd=(xn-(x_a5_2(in-1,jn,kn)))/(x_a5_2(in,jn,kn)-(x_a5_2(in-1,jn,kn)))
yd=(yn-(yv_a5_2(in,jn-1,kn)))/(yv_a5_2(in,jn,kn)-(yv_a5_2(in,jn-1,kn)))
zd=(zn-z_a5_2(in,jn,kn-1))/(z_a5_2(in,jn,kn)-z_a5_2(in,jn,kn-1))


 c00=V_a5_2(in-1,jn-1,kn-1)*(1.-xd)+V_a5_2(in,jn-1,kn-1)*xd
 c01=V_a5_2(in-1,jn-1,kn)*(1.-xd)+V_a5_2(in,jn-1,kn)*xd
 c10=V_a5_2(in-1,jn,kn-1)*(1.-xd)+V_a5_2(in,jn,kn-1)*xd
 c11=V_a5_2(in-1,jn,kn)*(1.-xd)+V_a5_2(in,jn,kn)*xd


 c0=c00*(1.-yd)+c10*yd
 c1=c01*(1.-yd)+c11*yd

 c=c0*(1.-zd)+c1*zd
 
 

 vnorm2=c

 !wwind!!!!!!!!!!!!!!!!!!!!!!!!!!!

findin=0.
findjn=0.
findkn=0.

do i=1,nx

if(findin .le.0.) then
if(x_a5_2(i,1,1) .ge. xn) then
in=i
findin=findin+1.

endif
endif
enddo


do j=1,ny
if(findjn .le. 0.) then
if(y_a5_2(1,j,1) .ge. yn) then
jn=j
findjn=findjn+1.
endif
endif
enddo


do k=1,nz
if(findkn .le. 0.) then
if(zw_a5_2(1,1,k) .ge. zn) then
kn=k
findkn=findkn+1.
endif
endif
enddo


xd=(xn-(x_a5_2(in-1,jn,kn)))/(x_a5_2(in,jn,kn)-(x_a5_2(in-1,jn,kn)))
yd=(yn-(y_a5_2(in,jn-1,kn)))/(y_a5_2(in,jn,kn)-(y_a5_2(in,jn-1,kn)))
zd=(zn-zw_a5_2(in,jn,kn-1))/(zw_a5_2(in,jn,kn)-zw_a5_2(in,jn,kn-1))


 c00=W_a5_2(in-1,jn-1,kn-1)*(1.-xd)+W_a5_2(in,jn-1,kn-1)*xd
 c01=W_a5_2(in-1,jn-1,kn)*(1.-xd)+W_a5_2(in,jn-1,kn)*xd
 c10=W_a5_2(in-1,jn,kn-1)*(1.-xd)+W_a5_2(in,jn,kn-1)*xd
 c11=W_a5_2(in-1,jn,kn)*(1.-xd)+W_a5_2(in,jn,kn)*xd


 c0=c00*(1.-yd)+c10*yd
 c1=c01*(1.-yd)+c11*yd

 c=c0*(1.-zd)+c1*zd
 
 

 wnorm2=c


 !km!!!!!!!!!!!!!!!!!!!!!!!!!!!

findin=0.
findjn=0.
findkn=0.

do i=1,nx

if(findin .le.0.) then
if(x_a5_2(i,1,1) .ge. xn) then
in=i
findin=findin+1.

endif
endif
enddo


do j=1,ny
if(findjn .le. 0.) then
if(y_a5_2(1,j,1) .ge. yn) then
jn=j
findjn=findjn+1.
endif
endif
enddo


do k=1,nz
if(findkn .le. 0.) then
if(z_a5_2(1,1,k) .ge. zn) then
kn=k
findkn=findkn+1.
endif
endif
enddo


xd=(xn-(x_a5_2(in-1,jn,kn)))/(x_a5_2(in,jn,kn)-(x_a5_2(in-1,jn,kn)))
yd=(yn-(y_a5_2(in,jn-1,kn)))/(y_a5_2(in,jn,kn)-(y_a5_2(in,jn-1,kn)))
zd=(zn-z_a5_2(in,jn,kn-1))/(z_a5_2(in,jn,kn)-z_a5_2(in,jn,kn-1))


 c00=DKM_a5_2(in-1,jn-1,kn-1)*(1.-xd)+DKM_a5_2(in,jn-1,kn-1)*xd
 c01=DKM_a5_2(in-1,jn-1,kn)*(1.-xd)+DKM_a5_2(in,jn-1,kn)*xd
 c10=DKM_a5_2(in-1,jn,kn-1)*(1.-xd)+DKM_a5_2(in,jn,kn-1)*xd
 c11=DKM_a5_2(in-1,jn,kn)*(1.-xd)+DKM_a5_2(in,jn,kn)*xd


 c0=c00*(1.-yd)+c10*yd
 c1=c01*(1.-yd)+c11*yd

 c=c0*(1.-zd)+c1*zd
 
 dkmnorm2=c


u_norm2=sqrt(unorm2**2.+vnorm2**2.+wnorm2**2.) 
 
 
 
 
print*, 'unorm2', unorm2, vnorm2, wnorm2, u_norm2




!-----------------------------------------------------------------
!---------Normierung der Felder-----------------------------------
!-----------------------------------------------------------------

do k=1,nz
do j=1,ny
do i=1,nx
IF(upol(i,j,k) .ne.-9999.)THEN
upol(i,j,k)=upol(i,j,k)/u_norm
ELSE
upol(i,j,k)=-9999.
ENDIF
enddo
enddo
enddo

do k=1,nz
do j=1,ny
do i=1,nx
IF(vpol(i,j,k) .ne.-9999.)THEN
vpol(i,j,k)=vpol(i,j,k)/u_norm
ELSE
vpol(i,j,k)=-9999.
ENDIF
enddo
enddo
enddo

do k=1,nz
do j=1,ny
do i=1,nx
IF(wpol(i,j,k) .ne.-9999.)THEN
wpol(i,j,k)=wpol(i,j,k)/u_norm
ELSE
wpol(i,j,k)=-9999.
ENDIF
enddo
enddo
enddo

do k=1,nz
do j=1,ny
do i=1,nx
IF(DKMpol(i,j,k) .ne.-9999.)THEN
DKMpol(i,j,k)=DKMpol(i,j,k)/dkmnorm   !???
ELSE
DKMpol(i,j,k)=-9999.
ENDIF
enddo
enddo
enddo

!a5-2
do k=1,nz
do j=1,ny
do i=1,nx
IF(upol2(i,j,k) .ne.-9999.)THEN
upol2(i,j,k)=upol2(i,j,k)/u_norm2
ELSE
upol2(i,j,k)=-9999.
ENDIF
enddo
enddo
enddo

do k=1,nz
do j=1,ny
do i=1,nx
IF(vpol2(i,j,k) .ne.-9999.)THEN
vpol2(i,j,k)=vpol2(i,j,k)/u_norm2
ELSE
vpol2(i,j,k)=-9999.
ENDIF
enddo
enddo
enddo

do k=1,nz
do j=1,ny
do i=1,nx
IF(wpol2(i,j,k) .ne.-9999.)THEN
wpol2(i,j,k)=wpol2(i,j,k)/u_norm2
ELSE
wpol2(i,j,k)=-9999.
ENDIF
enddo
enddo
enddo

do k=1,nz
do j=1,ny
do i=1,nx
IF(DKMpol2(i,j,k) .ne.-9999.)THEN
DKMpol2(i,j,k)=DKMpol2(i,j,k)/dkmnorm2    !????
ELSE
DKMpol2(i,j,k)=-9999.
ENDIF
enddo
enddo
enddo


!-------------------------------------------------------------
!----Transformation von a5-2 auf das Gitter von a5-1-------------
!-------------------------------------------------------------


do k=1,nz
do j=1,ny
do i=1,nx
IF(upol2(i,j,k) .ne. -9999. .and. vpol2(i,j,k) .ne. -9999..and. upol2(i,j,k) .ne. 0.)THEN


U_a5_2_t(i,j,k)=upol2(i,j,k)*cos(-45.*winkel)+vpol2(i,j,k)*sin(-45.*winkel)
V_a5_2_t(i,j,k)=-upol2(i,j,k)*sin(-45.*winkel)+vpol2(i,j,k)*cos(-45.*winkel)



ELSE
U_a5_2_t(i,j,k)=-9999.
V_a5_2_t(i,j,k)=-9999.
ENDIF

enddo
enddo
enddo


do k=1,nz
do j=1,ny
do i=1,nx
x_a5_2_t(i,j,k)=xpol2(i,j,k)*cos(-45.*winkel)+ypol2(i,j,k)*sin(-45.*winkel)
y_a5_2_t(i,j,k)=-xpol2(i,j,k)*sin(-45.*winkel)+ypol2(i,j,k)*cos(-45.*winkel)
enddo
enddo
enddo


! do i=1,nx
! do j=1,ny
! do k=1,16
! 
! 
! WRITE(50,*), x_a5_2_t(i,j,k), y_a5_2_t(i,j,k), zpol(i,j,k), U_a5_2_t(i,j,k)
! 
! enddo
! enddo
! enddo



!-------------------------------------------------------------
!----Interpolieren des transformierten a5-2 Gitters auf a5-1-------------
!-------------------------------------------------------------
!Anfangs- und Endpunkte von a5-1 fuer den Nahbereich 
ia=33!48
ie=188!94
ja=27!53
je=185!79
do n=1,16
do m=ja,je
do l=ia,ie


xa51=xpol(l,m,n)
ya51=ypol(l,m,n)



find=0
drei=0




DO i=1,nx
DO j=1,ny




IF(xa51 .gt. x_a5_2_t(i-1,j,n) .and. ya51 .gt. y_a5_2_t(i-1,j-1,n) .and. xa51 .le. x_a5_2_t(i,j-1,n) .and.  ya51 .le. y_a5_2_t(i,j,n))THEN
!befindet sich im Quadrat um das gedrehte Rechengebiet
!1. Dreieck ausschließen
IF(xa51 .le. x_a5_2_t(i-1,j-1,n) .and. ya51 .le. y_a5_2_t(i-1,j,n) .and. abs(y_a5_2_t(i-1,j,n)-ya51) .le.   abs(x_a5_2_t(i-1,j,n)-xa51))THEN
! PRINT*, '1. Dreieck'
find=1
drei=1
ENDIF
!2. Dreieck ausschließen
IF(xa51 .le. x_a5_2_t(i-1,j-1,n) .and. ya51 .gt. y_a5_2_t(i-1,j,n) .and. abs(y_a5_2_t(i-1,j,n)-ya51) .le.   abs(x_a5_2_t(i-1,j,n)-xa51))THEN
! PRINT*, '2. Dreieck'
find=1
drei=2
ENDIF
!3. Dreieck ausschließen
IF(xa51 .gt. x_a5_2_t(i-1,j-1,n) .and. ya51 .gt. y_a5_2_t(i-1,j,n) .and. abs(y_a5_2_t(i,j-1,n)-ya51) .le.   abs(x_a5_2_t(i,j-1,n)-xa51))THEN
! PRINT*, '3. Dreieck'
find=1
drei=3
ENDIF
!4. Dreieck ausschließen
IF(xa51 .gt. x_a5_2_t(i-1,j-1,n) .and. ya51 .le. y_a5_2_t(i-1,j,n) .and. abs(y_a5_2_t(i,j-1,n)-ya51) .le.   abs(x_a5_2_t(i,j-1,n)-xa51))THEN
! PRINT*, '4. Dreieck'
find=1
drei=4
ENDIF



IF(find.eq.1)THEN
ie1=i
je1=j
ie2=i-1
je2=j
ie3=i-1
je3=j-1
ie4=i
je4=j-1


ENDIF

ENDIF
 

 
IF(find==1)EXIT

ENDDO
ENDDO


IF(drei .eq. 2 .or. drei .eq. 3)THEN
hyp=sqrt((xa51-x_a5_2_t(ie2,je2,n))**2+(ya51-y_a5_2_t(ie2,je2,n))**2)
gegenk=abs(ya51-y_a5_2_t(ie2,je2,n))
alpha=abs(45.-asin(gegenk/hyp)/winkel)
x=hyp*sin(alpha*winkel)
y=hyp*cos(alpha*winkel)
xd=x/2.5
yd=y/2.5
ENDIF



IF(drei .eq. 1 .or. drei .eq. 4)THEN
hyp=sqrt((xa51-x_a5_2_t(ie4,je4,n))**2+(ya51-y_a5_2_t(ie4,je4,n))**2)
gegenk=abs(ya51-y_a5_2_t(ie4,je4,n))
alpha=abs(45.-asin(gegenk/hyp)/winkel)
x=hyp*sin(alpha*winkel)
y=hyp*cos(alpha*winkel)
xd=1-x/2.5
yd=1-y/2.5
ENDIF



! U-Komponente
IF(U_a5_2_t(ie4,je4,n) .ne. -9999. .and. U_a5_2_t(ie3,je3,n) .ne. -9999..and. U_a5_2_t(ie2,je2,n) .ne. -9999. .and. U_a5_2_t(ie1,je1,n) .ne. -9999. )THEN 

!wichtung der Eckpunkte
 c01=U_a5_2_t(ie4,je4,n)*xd+U_a5_2_t(ie1,je1,n)*(1.-xd)
 c02=U_a5_2_t(ie3,je3,n)*xd+U_a5_2_t(ie2,je2,n)*(1.-xd)

 c=c02*(1.-yd)+c01*yd
 ELSE
 
 c=-9999.
 ENDIF
 

 
U_auf_a5_1(l,m,n)=c

! V-Komponente
IF(V_a5_2_t(ie4,je4,n) .ne. -9999. .and. V_a5_2_t(ie3,je3,n) .ne. -9999..and. V_a5_2_t(ie2,je2,n) .ne. -9999. .and. V_a5_2_t(ie1,je1,n) .ne. -9999. )THEN 

!wichtung der Eckpunkte
 c01=V_a5_2_t(ie4,je4,n)*xd+V_a5_2_t(ie1,je1,n)*(1.-xd)
 c02=V_a5_2_t(ie3,je3,n)*xd+V_a5_2_t(ie2,je2,n)*(1.-xd)

 c=c02*(1.-yd)+c01*yd
 ELSE
 
 c=-9999.
 ENDIF
 
V_auf_a5_1(l,m,n)=c


! W-Komponente
IF(wpol2(ie4,je4,n) .ne. -9999. .and. wpol2(ie3,je3,n) .ne. -9999..and. wpol2(ie2,je2,n) .ne. -9999. .and. wpol2(ie1,je1,n) .ne. -9999. )THEN 

!wichtung der Eckpunkte
 c01=wpol2(ie4,je4,n)*xd+wpol2(ie1,je1,n)*(1.-xd)
 c02=wpol2(ie3,je3,n)*xd+wpol2(ie2,je2,n)*(1.-xd)

 c=c02*(1.-yd)+c01*yd
 ELSE
 
 c=-9999.
 ENDIF
 
W_auf_a5_1(l,m,n)=c


! Km-Komponente
IF(DKMpol2(ie4,je4,n) .ne. -9999. .and. DKMpol2(ie3,je3,n) .ne. -9999..and. DKMpol2(ie2,je2,n) .ne. -9999. .and. DKMpol2(ie1,je1,n) .ne. -9999. )THEN 

!wichtung der Eckpunkte
 c01=DKMpol2(ie4,je4,n)*xd+DKMpol2(ie1,je1,n)*(1.-xd)
 c02=DKMpol2(ie3,je3,n)*xd+DKMpol2(ie2,je2,n)*(1.-xd)

 c=c02*(1.-yd)+c01*yd
 ELSE
 
 c=-9999.
 ENDIF
 
DKM_auf_a5_1(l,m,n)=c





enddo
enddo
enddo


do i=ia,ie
do j=ja,je
do k=1,16


WRITE(40,*), xpol(i,j,k), ypol(i,j,k), zpol(i,j,k), upol(i,j,k), U_auf_a5_1(i,j,k)

enddo
enddo
enddo


!---------------Berechnung von i,j,k aus x,y,z-------------------

U_zaehl=0
V_zaehl=0
W_zaehl=0
DKM_zaehl=0
U_zaehl_T=0
V_zaehl_T=0
W_zaehl_T=0
DKM_zaehl_T=0



do k=1,16
do j=ja,je
do i=ia,ie


IF(upol(i,j,k) .ne. -9999. .and. U_auf_a5_1(i,j,k) .ne. -9999.)THEN

D=ABS((U_auf_a5_1(i,j,k)-upol(i,j,k))/upol(i,j,k))
W=ABS(U_auf_a5_1(i,j,k)-upol(i,j,k))

IF(D .LE. 0.25 .OR. W .LE. 0.06)THEN
U_zaehl_T=U_zaehl_T+1.
ENDIF

U_zaehl=U_zaehl+1.



ENDIF


IF(vpol(i,j,k) .ne. -9999. .and. V_auf_a5_1(i,j,k) .ne. -9999.)THEN

D=ABS((V_auf_a5_1(i,j,k)-vpol(i,j,k))/vpol(i,j,k))
W=ABS(V_auf_a5_1(i,j,k)-vpol(i,j,k))

IF(D .LE. 0.25 .OR. W .LE. 0.06)THEN
V_zaehl_T=V_zaehl_T+1.
ENDIF
V_zaehl=V_zaehl+1.

ENDIF


IF(wpol(i,j,k) .ne. -9999. .and. W_auf_a5_1(i,j,k) .ne. -9999.)THEN

D=ABS((W_auf_a5_1(i,j,k)-wpol(i,j,k))/wpol(i,j,k))
W=ABS(W_auf_a5_1(i,j,k)-wpol(i,j,k))

IF(D .LE. 0.25 .OR. W .LE. 0.06)THEN
W_zaehl_T=W_zaehl_T+1.
ENDIF
W_zaehl=W_zaehl+1.

ENDIF


IF(DKMpol(i,j,k) .ne. -9999. .and. DKM_auf_a5_1(i,j,k) .ne. -9999.)THEN

D=ABS((DKM_auf_a5_1(i,j,k)-DKMpol(i,j,k))/DKMpol(i,j,k))
W=ABS(DKM_auf_a5_1(i,j,k)-DKMpol(i,j,k))

IF(D .LE. 0.25 .OR. W .LE. 0.06)THEN
DKM_zaehl_T=DKM_zaehl_T+1.
ENDIF
DKM_zaehl=DKM_zaehl+1.

ENDIF


ENDDO
ENDDO
ENDDO











PRINT*, 'Testfall a5:'
PRINT*, ' '


PRINT*, 'U:', U_zaehl_T/U_zaehl*100., '%'
PRINT*, 'V:', V_zaehl_T/V_zaehl*100., '%'
PRINT*,'W:', W_zaehl_T/W_zaehl*100., '%'
PRINT*, 'Km:', DKM_zaehl_T/DKM_zaehl*100., '%'
IF(U_zaehl_T/U_zaehl*100. .ge. 66. .and. V_zaehl_T/V_zaehl*100..ge. 66. .and.   W_zaehl_T/W_zaehl*100. .ge. 66. .and.   DKM_zaehl_T/DKM_zaehl*100. .ge. 66. )THEN
PRINT*, 'Testfall a5 bestanden!'
ENDIF






!------------------Testfall c3-------------------
U_zaehl_vdi=0
V_zaehl_vdi=0
W_zaehl_vdi=0

U_zaehl_T_vdi=0
V_zaehl_T_vdi=0
W_zaehl_T_vdi=0



OPEN(1,FILE='../comparative_data/VDI3783-9_Vergleichsdaten_Testfall_C3.dat')

DO m=1,20
READ(1,*)
ENDDO



do m=21,880
READ(1,*) a,xvdi,yvdi,zvdi,uvdi,vvdi,wvdi



aus1=0
do i=1,nx
IF(xpol(i,1,1) .ge.  xvdi)THEN
it=i
aus1=1
ENDIF
IF(aus1==1)EXIT
enddo


aus2=0
do j=1,ny

IF(ypol(3,j,3) .ge.  yvdi)THEN
jt=j
aus2=1
ENDIF
IF(aus2==1)EXIT
enddo

aus3=0
do k=1,nz-1
IF(zpol(5,5,k) .ge.  zvdi)THEN
kt=k
aus3=1
ENDIF
IF(aus3==1)EXIT
enddo

if(aus1==0 .or. aus2==0 .or. aus3==0)THEN
PRINT*, 'FEHLER', aus1, aus2, aus3, m
endif




xd=(xvdi-(xpol(it-1,jt,kt)))/(xpol(it,jt,kt)-(xpol(it-1,jt,kt)))
yd=(yvdi-(ypol(it,jt-1,kt)))/(ypol(it,jt,kt)-(ypol(it,jt-1,kt)))
zd=(zvdi-zpol(it,jt,kt-1))/(zpol(it,jt,kt)-zpol(it,jt,kt-1))


 c00=upol(it-1,jt-1,kt-1)*(1.-xd)+upol(it,jt-1,kt-1)*xd
 c01=upol(it-1,jt-1,kt)*(1.-xd)+upol(it,jt-1,kt)*xd
 c10=upol(it-1,jt,kt-1)*(1.-xd)+upol(it,jt,kt-1)*xd
 c11=upol(it-1,jt,kt)*(1.-xd)+upol(it,jt,kt)*xd


 c0=c00*(1.-yd)+c10*yd
 c1=c01*(1.-yd)+c11*yd

 c=c0*(1.-zd)+c1*zd
 unorm=c

 
 
 c00=vpol(it-1,jt-1,kt-1)*(1.-xd)+vpol(it,jt-1,kt-1)*xd
 c01=vpol(it-1,jt-1,kt)*(1.-xd)+vpol(it,jt-1,kt)*xd
 c10=vpol(it-1,jt,kt-1)*(1.-xd)+vpol(it,jt,kt-1)*xd
 c11=vpol(it-1,jt,kt)*(1.-xd)+vpol(it,jt,kt)*xd


 c0=c00*(1.-yd)+c10*yd
 c1=c01*(1.-yd)+c11*yd

 c=c0*(1.-zd)+c1*zd
 vnorm=c
! print*, it, jt, kt, unorm
! 
! print*, xpol(it,jt,kt), ypol(it,jt,kt), zpol(it,jt,kt)
! 
! 
! 
! print*, upol(it-1,jt-1,kt-1),upol(it,jt-1,kt-1),upol(it-1,jt-1,kt),upol(it,jt-1,kt)
! print*,upol(it-1,jt,kt-1),upol(it,jt,kt-1),upol(it-1,jt,kt),upol(it,jt,kt)


IF(unorm .ne. -9999. .and. uvdi .ne. -99.999 .and. uvdi .ne. 0.)THEN

D=ABS((unorm-uvdi)/uvdi)
W=ABS(unorm-uvdi)

IF(D .LE. 0.25 .OR. W .LE. 0.06)THEN
U_zaehl_T_vdi=U_zaehl_T_vdi+1.
ENDIF

U_zaehl_vdi=U_zaehl_vdi+1.



ENDIF


IF(vnorm .ne. -9999. .and. vvdi .ne. -99.999 .and. vvdi .ne. 0.)THEN


IF(m==21)PRINT*, vnorm, vvdi, unorm, uvdi, 'jj'

D=ABS((vnorm-vvdi)/vvdi)
W=ABS(vnorm-vvdi)

IF(D .LE. 0.25 .OR. W .LE. 0.06)THEN
V_zaehl_T_vdi=V_zaehl_T_vdi+1.
ENDIF

V_zaehl_vdi=V_zaehl_vdi+1.

ENDIF





IF(wnorm .ne. -9999. .and. wvdi .ne. -99.999 .and. wvdi .ne. 0.)THEN

D=ABS((wnorm-wvdi)/wvdi)
W=ABS(wnorm-wvdi)

IF(D .LE. 0.25 .OR. W .LE. 0.06)THEN
W_zaehl_T_vdi=W_zaehl_T_vdi+1.
ENDIF

W_zaehl_vdi=W_zaehl_vdi+1.

ENDIF






enddo



print*, W_zaehl_vdi, V_zaehl_vdi, U_zaehl_vdi


PRINT*, 'Testfall c3:'
PRINT*, ' '


PRINT*, 'U:', U_zaehl_T_vdi/U_zaehl_vdi*100., '%'
PRINT*, 'V:', V_zaehl_T_vdi/V_zaehl_vdi*100., '%'
PRINT*,'W:', W_zaehl_T/W_zaehl*100., '%'
IF(U_zaehl_T_vdi/U_zaehl_vdi*100. .ge. 66. .and. V_zaehl_T_vdi/V_zaehl_vdi*100..ge. 66. .and.   W_zaehl_T_vdi/W_zaehl_vdi*100. .ge. 66.)THEN
PRINT*, 'Testfall c3 bestanden!'
ENDIF






















END PROGRAM Vergleich






SUBROUTINE check(status)
    implicit none
        integer, intent ( in) :: status
        integer :: nf90_noerr
        
        if(status /= nf90_noerr) then 
          print *, "error"!trim(nf90_strerror(status))
          stop 2
        end if
END SUBROUTINE check 
